// userok var sto/rage = new simplemail.SimpleMail/StorageManager.SimpleMailSto/rage();

// OnLoad event fires twice when iframe is present (FF bug)
if (typeof(simplemail) == "undefined" ) {simplemail = {};};

simplemail.SimpleMailWindowMessage = function() {
  var pub = {};

  pub.initializeMessage = function() {
    //console.error("SM.SimpleMailWindowMessage_initializeMessage", this);//userok_log
    
    if (!simplemail.SimpleMailUtils.isFirefox2()) simplemail.SimpleMailDom.remove("grippy-style");
    initToolbarMode();
    
    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges

    simplemail.SimpleMailDom.get("body").docShell.allowJavascript = false;

    simplemail.SimpleMailDom.get("body").contentDocument.addEventListener("keypress", function(e) {
      if (!e.ctrlKey || String.fromCharCode(e.charCode) != 'a') {
        simplemail.messageTreeView.onKeyPress(e);
      }
    }, false);

    simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;

    message = simplemail.SimpleMailPrefs.getObject('message');
    messageTree = simplemail.SimpleMailPrefs.getObject('messageTree');
    messageTree.view = simplemail.messageTreeView;
    var browserWindow = simplemail.SimpleMailUtils.getBrowserWindow();

    var body = simplemail.SimpleMailDom.get("body");
    simplemail.messageTreeView.displayHeaders(message);
    var html = message.partial
           ? simplemail.SimpleMailBundle.getString("messageNotDownloaded")
           : message.id ? simplemail.SimpleMailOverlay.storage.getMessage(message.id).html : " "; // userok

    var originalHTML = html;
    
    if (html !== " ") {
      var source = simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
      source.append(simplemail.SimpleMailFile.MESSAGE_SOURCE);
      source = simplemail.SimpleMailFile.readFile(source);
    }
    
    if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") && html !== " ") {
      var partAttachs = simplemail.messageTreeView.displayAttachments(html, message);
      
      var attachments = new Array();
      simplemail.SimpleMailMessageEncoder.cidNames = [];
      simplemail.SimpleMailMessageEncoder.ContentId = [];
      simplemail.SimpleMailMessageEncoder.ContentDisposition = [];
      simplemail.SimpleMailMessageEncoder.ContentType = [];
      var tmpMessage = simplemail.SimpleMailMessageEncoder.parse(source, attachments, simplemail.SimpleMailMessageEncoder.cidNames, simplemail.SimpleMailMessageEncoder.ContentId, simplemail.SimpleMailMessageEncoder.ContentDisposition, simplemail.SimpleMailMessageEncoder.ContentType);
  
      if (!source.match(/name\=/gim) && !source.match(/filename\=/gim) && !source.match(/Content\-ID\:/gim) || partAttachs == null){  // No Attachments
        var html = simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, true);
        html = simplemail.messageTreeView.plaintextMessage(html);
        html = html.replace(/(\r\n).*?/g,"<br>"); 
      } else {
        if (partAttachs != null) {
          partAttachs = partAttachs.join("");
        }      
        if (source.match(/text\/plain/gim)) { // Plaintext part in the message
          var html = tmpMessage.html + "<br>" + partAttachs;
          var html = simplemail.SimpleMailUtils.parseHTML(document, html, true);
          html = simplemail.messageTreeView.plaintextMessage(html);
        } else {
          // Remove Inline images
          var getImages = tmpMessage.html.toString().match(/<img[^>]*>(.*?)>*/gim); 
          if (getImages != null){
            for (var i in getImages){
              tmpMessage.html = tmpMessage.html.replace(getImages[i], "");
            }
          }
          var html = simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, true);
          html = simplemail.messageTreeView.plaintextMessage(html);
          html = html.replace(/(\r\n).*?/g,"<br>");   
          html = html  + "<br>" + partAttachs;
        }
      }
  
      if (!(simplemail.SimpleMailOverlay.storage.getMessage(message.id).html).match(/\<a\sclass\=\'attachment\'/gim)) {
        message.html = originalHTML;
        simplemail.SimpleMailOverlay.storage.updateMessage(0, message); // userok: async
      }
    } else {
      html = simplemail.messageTreeView.displayAttachments(html, message);
    }
    
    html = simplemail.SimpleMailText.imageToLink(html);
    
    // Change : remove : i don't remember what does this does !!
    /*if (html !== " " && source.toString().match(/Content\-Type\: text\/plain/gim) && simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
      html = simplemail.SimpleMailText.linkToLink(html);
    } */
    
    body.contentDocument.title = message.subject;
    
    if(simplemail.SimpleMailPrefs.getBool("removeImages") || simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
      var getHtmlImages = html.toString().match(/<img[^>]*>(.*?)>*/gim);
      if (getHtmlImages != null){
        for (var k in getHtmlImages){ 
          if (getHtmlImages[k].match(/http/gim)){
            var html = html.replace(getHtmlImages[k], simplemail.SimpleMailBundle.getString("removedimages"));
          }
        }
      }
      if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
        html = simplemail.SimpleMailText.linkToText(html);
      }
    }
      
    var fragment = simplemail.SimpleMailUtils.parseHTML(body.contentDocument, html, true);
    body.contentDocument.body.innerHTML = "";
    body.contentDocument.body.appendChild(fragment);
    
    if (message.returnReceiptTo &&
        message.uid && !message.partial)
    {
      simplemail.messageTreeView.sendReturnReceipt(message);
    }
  
    clearTimeout(simplemail.messageTreeView.markReadTimeout);
    
    if (!message.read && !message.partial) {
      simplemail.messageTreeView.startMarkReadTimeout(message);
    }
  }
  return pub;
}();
      
function initToolbarMode() {
  var mode = simplemail.SimpleMailPrefs.getString("toolbarMode");
  simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", mode);

  var menuitems = simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
  for(var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].value == mode) {
      menuitems[i].setAttribute("checked", true);
    }
  }
    if (simplemail.SimpleMailPrefs.getBool("old")) {
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("nuvola")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("oxygen")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("australis")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
    }
}

function updateToolbarMode() {
  var menuitems = simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
  for(var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].getAttribute("checked")) {
      simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
      simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
    }
  }
}

function updateFavIcon() {
  console.error("SM.msgwnd_updateFavIcon");//userok_log
  var tab      = simplemail.SimpleMailUtils.getDocumentTab(document);
  var gBrowser = simplemail.SimpleMailUtils.getBrowser();
  var status   = simplemail.SimpleMailOverlay.getStatus();
  var icon     = simplemail.SimpleMailFile.getStatusIconURL(status);
  gBrowser.setIcon(tab, icon);
}

function reply(all) {
  if (!simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
    simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
  }
  simplemail.SimpleMailPrefs.setObject('message', message);
  setTimeout(function(){simplemail.messageTreeView.openReply(all);}, 250); 
}

function forward() {
  if (!simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
    simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
  }
  simplemail.SimpleMailPrefs.setObject('message', message);
  setTimeout(function(){simplemail.messageTreeView.openForward();}, 250); 
}

function deleteThisMail(message) {
  if (message.folderId != simplemail.SimpleMailModel.SimpleMailFolder.TRASH & simplemail.SimpleMailPrefs.getBool("moveToTrash")) {
    message.folderId = simplemail.SimpleMailModel.SimpleMailFolder.TRASH 
    
    // Manage SPAMs
    if (message.folderId == simplemail.SimpleMailManageFolder.getFolderId("SPAM")) {
      message.spam = true;
      var messageFrom = message.from;
      processFilterSPAM(messageFrom);
    } else if (message.folderId !== simplemail.SimpleMailManageFolder.getFolderId("SPAM") && message.spam == true) {
      message.spam = false;
      var messageFrom = message.from;
      deleteRuleFilterSPAM(messageFrom);
    }
    simplemail.SimpleMailOverlay.storage.saveMessageState(message); // userok
  } else {
    var msgs = new Array();
    msgs.push(message);
    var confirmText = simplemail.SimpleMailBundle.getString("deleteMessages");
    simplemail.SimpleMailOverlay.askDeleteMail(msgs, confirmText, window);
  }
  var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
  window.close();
  if (mainWindow) mainWindow.history.go();
}

function saveMessageAs() {
  simplemail.SimpleMailPrefs.setObject('message', message);
  simplemail.messageTreeView.saveMessageAs();
}      

function print() {
  simplemail.SimpleMailPrefs.setObject('message', message);
  simplemail.messageTreeView.printMessage();
}

function onClose() {
  simplemail.SimpleMailPrefs.clear('message');
  simplemail.SimpleMailPrefs.clear('messageTree');
  simplemail.SimpleMailPrefs.clear('messageIndex');
  simplemail.SimpleMailPrefs.clear('folderIndex');
}